//
void ToI2CAdr1B(int MemAdr)  {  // push 8bit address with control code into the command report
	ToCmdBuf(2);
	ToCmdBuf((MemAdr >> 8) << 1 | 0xA0);
	ToCmdBuf(MemAdr);
}
void ToI2CAdr2B(int MemAdr) {
	ToCmdBuf(3);
	ToCmdBuf((MemAdr >> 16) << 1 | 0xA0);
	ToCmdBuf(MemAdr >> 8);
	ToCmdBuf(MemAdr);
}
rc InitI2C() {
	InitCmdBuf();
	ToCmdBuf(CmdSMB0En);
	return (SendCmdPKG());
}
rc SetI2CAdr(int MemAdr) {
	InitCmdBuf();
	ToCmdBuf(CmdSMB0Start);
	ToCmdBuf(CmdSMB0WriteN);
	pfToI2CAdr(MemAdr);
	ToCmdBuf(CmdSMB0Stop);
	return (SendCmdPKG());
}
// data was embedded in the command report, usually for vCell/Page <= 32
// for vCell/Page <= 32. vpData must have already been set, and will be updated when exit.
void _I2CWritePageS(int MemAdr) {
    int i;
	InitCmdBuf();
	ToCmdBuf(CmdSMB0Start);
	ToCmdBuf(CmdSMB0WriteN);
	pfToI2CAdr(MemAdr);
	ToCmdBuf(CmdSMB0WriteN);
	ToCmdBuf(CellPerPage);
	// fill-in data
	for(i=0; i < CellPerPage; i++) {
 	  ToCmdBuf(*vpData);
	  vpData++;
	}
	ToCmdBuf(CmdSMB0Stop);
	ToWait10MS();  // wait 10ms for write complete
}
rc I2CDownBufS(int len) {  // write from the current IC address
	int Pages, i;
	vpData = SSEG1;
	Pages = (len + CellPerPage -1) / CellPerPage;
	for(i=0; i<Pages; i++) {
	  _I2CWritePageS(ICAdr);
	  if (SendCmdPKG()) return 1;
	  ICAdr = ICAdr + CellPerPage;  // update IC address
	}
	return 0;
}
// data was sent separately by data report, usually for vCell/Page >= 64
void _I2CWritePageL(int MemAdr) {
	InitCmdBuf();
	ToCmdBuf(CmdLoadReportN);
	ToCmdBuf(ReportPerPage);  // load so many reports into XDATA page buffer
	ToCmdBuf(CmdSMB0Start);  // chip enable
	ToCmdBuf(CmdSMB0WriteN);  // write chip address
	pfToI2CAdr(MemAdr);
	ToCmdBuf(CmdSMB0UnloadN);  // unload data into chip page
	ToCmdBuf(CellPerPage);
	ToCmdBuf(CmdSMB0Stop);  // chip disable
	ToWait10MS();  // wait 10ms for write complete
}
rc I2CDownBufL(int len) {
	int Pages, i;
	vpData = SSEG1;  // initial the buffer pointer
	Pages = (len + CellPerPage -1) / CellPerPage;
	for (i=0; i<Pages; i++) {
	  _I2CWritePageL(ICAdr);  // prepare the command report
	  if (WriteReport(OutBuf)) return 1;  // send out the command report
      temp = ReportPerPage;
      while (temp) {  // load page data with data report
        LoadOutBuf();
        if (WriteReport(OutBuf)) return 2;
        temp--;
  	  }
  	  if (CheckStatusRPT()) return 3;
      ICAdr = ICAdr + CellPerPage;  // update IC address
	}
	return 0;
}

// data upload
void _I2CReadReports(int Reports) {
	InitCmdBuf();
	ToCmdBuf(CmdSMB0Start);
	ToCmdBuf(CmdSMB0WriteN);
	ToCmdBuf(1);
	ToCmdBuf(0xA1);
	ToCmdBuf(CmdSMB0ReadReportL);
	ToCmdBuf(Reports >> 8);  ToCmdBuf(Reports);	 // need to read so many reports
	ToCmdBuf(CmdSMB0NACKStop);
}
rc I2CUpBuf() {
	int Reports, i, j;
	Reports = (ReportPerIC <= ReportPerBuf) ? ReportPerIC : ReportPerBuf;
	_I2CReadReports(Reports);  // prepare the command report
	if (WriteReport(OutBuf)) return 1;  // send out the command report
	vpData = SSEG1;
	for(i=0; i < Reports; i++) {  // read reports into buffer
	  if (ReadReport(InBuf))  return 1;
	  for(j=0; j < PKGLen; j++)  *vpData++ = InBuf[j];
	}
	return CheckStatusRPT();
}

rc UpI2C() {
	if (SetI2CAdr(0))  return (ReadReport(InBuf));
	pfUpBuf = I2CUpBuf;  // set vector
	return (UpIC());
}
rc DownI2C() {
	if (SetI2CAdr(0))  return (ReadReport(InBuf));
	return (DownIC());
}
void Init24C04() {
	pfToI2CAdr = ToI2CAdr1B;  // set vector
	pfDownBuf = I2CDownBufS;  // set vector
	CellPerPage = 8;
	PagePerIC = 64;
	SetPara();
}
void Init24C512() {
	pfToI2CAdr = ToI2CAdr2B;  // set vector
	pfDownBuf = I2CDownBufL;  // set vector
	CellPerPage = 128;
	PagePerIC = 512;
	SetPara();
}

int main(int argc, char* argv[]) {
	// Input user parameters
	char ic, rw, yn;
	char name[80];
	printf("select (1)AT24C04 (2)AT24C512 or ESC to abort:");
	while (!((ic = getch()) == 0x1B || ic == '1' || ic == '2'));
	if (ic == 0x1B)  return 0;
    putch(ic);
	printf("\nSelect (1)Read (2)Write or ESC to abort:");
	while (!((rw = getch()) == 0x1B || rw == '1' || rw == '2'));
	if (rw == 0x1B)  return 0;
    putch(rw);
	do {
	  printf("\nEnter filename:");
	  gets(name);
	  if (rw == '1')  temp = ((fp = fopen(name, "wb")) == NULL);
	  else  temp = ((fp = fopen(name, "rb")) == NULL);
	  if (temp)  printf("\nCan't open %s\n", name);
	  else  break;
	  printf("\nRetry (1)Yes (2)No:");
	  while (!((yn = getch()) == '1' || yn == '2'));
      putch(yn);
	  if (yn == '2')  return 0;
	} while (1);
	// File is opened. Now open the DLL
    HINSTANCE hDLL = LoadLibrary("F320hid.dll");
    if (hDLL == NULL)  return 1;
    OpenU2A = (OpenU2A_type)GetProcAddress(hDLL, "OpenU2A");
    CloseU2A = (CloseU2A_type)GetProcAddress(hDLL, "CloseU2A");
    ReadReport = (ReadReport_type)GetProcAddress(hDLL, "ReadReport");
    WriteReport = (WriteReport_type)GetProcAddress(hDLL, "WriteReport");
	// open device
    rcode = OpenU2A();
    if (rcode)  {FreeLibrary(hDLL);  fclose(fp);  return 1;}

    // I2C test
    if (PowerOn())  goto error;
    if (SelSIO())  goto error;
    if (InitI2C())  goto error;
    if (ic == '1')  Init24C04();  else  Init24C512();
    if (rw == '1')  rcode = UpI2C();  else  rcode = DownI2C();
	PowerOff();

    // The codes below are common to all applications
    error:
    CloseU2A();
	FreeLibrary(hDLL);
    fclose(fp);
    if (rcode)  {
	  printf("\nError occurs at offset %d in command reprot", ((InBuf[1] & 0x3F)-1));
	  printf("\nPress any key to exit");
      getch();
	}
    return rcode;
}
