// Analog input
rc EnADC() {
	InitCmdBuf();
	ToCmdBuf(CmdADC0En);
	return (SendCmdPKG());
}
rc DisADC() {
	InitCmdBuf();
	ToCmdBuf(CmdADC0Dis);
	return (SendCmdPKG());
}
rc SetAMX(int amx) {
	InitCmdBuf();
	ToCmdBuf(CmdADC0SetAMX);
	ToCmdBuf(amx >> 8);  ToCmdBuf(amx);
	return (SendCmdPKG());
}
rc GetADC() {
	InitCmdBuf();
	ToCmdBuf(CmdADC0Get);
	return (SendCmdPKG());
}

// SW1=P07, SW2=P06, LED1=P04,
// make LED1 follows SW1 status until SW2 was depressed
#define bSW1 0x80
#define bSW2 0x40
#define bLED1 0x10

int main(int argc, char* argv[]) {
    HINSTANCE hDLL = LoadLibrary("F320hid.dll");
    if (hDLL == NULL)  return 1;
    OpenU2A = (OpenU2A_type)GetProcAddress(hDLL, "OpenU2A");
    CloseU2A = (CloseU2A_type)GetProcAddress(hDLL, "CloseU2A");
    ReadReport = (ReadReport_type)GetProcAddress(hDLL, "ReadReport");
    WriteReport = (WriteReport_type)GetProcAddress(hDLL, "WriteReport");

    rcode = OpenU2A();
    if (rcode)  {FreeLibrary(hDLL);  return 1;}
    // The above codes are common to all kinds of applications

    // I/O test
    if (PowerOn())  goto error;
    if (SelEPP())  goto error;
  	if (EnADC())  goto error;  // Reference voltage is VDD, left-justified
  	SetAMX(0x0D1F);  // positive signal is P2.5, negative signal is GND
    do {
	  if (ReadSFR(P0))  goto error;  // read P0
	  temp = InBuf[2];  // get P0 data
	  if (temp & bSW1)  WriteSFR((temp | bLED1), P0);  // SW1 not pressed
	  else {
		WriteSFR((temp & ~bLED1 | bSW1), P0);  // SW1 pressed, set SW1 back to input
	    if (GetADC())  goto error;  // get ADC
	    printf("\nHigh 8-bits data is %x", InBuf[2]);
  	  }
  	} while (temp & bSW2);  // until SW2 depressed
  	PowerOff();

    error:
    CloseU2A();
    FreeLibrary(hDLL);
    if (rcode)  {
	  printf("\nError occurs at offset %d in command reprot", ((InBuf[1] & 0x3F)-1));
	  printf("\nPress any key to exit");
      getch();
	}
    return rcode;
}

