// define 25 series flash device command
#define READ 0x03
#define WREN 0x06
#define PP 0x02
#define CER 0xC7
#define RDID 0x9F
#define WRSR 0x01
//
void ToSPIAdr3B(int MemAdr) {  // push 24bit address into the command report
	ToCmdBuf(3);
	ToCmdBuf(MemAdr >> 16);
	ToCmdBuf(MemAdr >> 8);
	ToCmdBuf(MemAdr);
}
rc InitSPI() {
	InitCmdBuf();
	ToCmdBuf(CmdSPI0En);
	return (SendCmdPKG());
}
rc SPIDis() {
	InitCmdBuf();
	ToCmdBuf(CmdSPI0Dis);
	return (SendCmdPKG());
}
rc WaitWIP(int len) {  // wait at most len*10ms for WIP to ready
	InitCmdBuf();
	ToCmdBuf(CmdWaitWIPL);
	ToCmdBuf(len >> 8);
	ToCmdBuf(len);
	return (SendCmdPKG());
}
void _SPIWritePage(int MemAdr) {
	InitCmdBuf();
	ToCmdBuf(CmdLoadReportN);  // load page into XDATA buffer
	ToCmdBuf(ReportPerPage);
	ToCmdBuf(CmdWaitWIPL);  // wait the previous write to complete
	ToCmdBuf(0);  ToCmdBuf(2);  // for at most 2x10ms
	ToCmdBuf(CmdSPI0CS0_Byte);  // Chip enable with "WREN" command
	ToCmdBuf(WREN);
	ToCmdBuf(CmdSPI0CS1);  // Chip disable
	ToCmdBuf(CmdSPI0CS0_Byte);  // Chip enable with "PP" command
	ToCmdBuf(PP);
	ToCmdBuf(CmdSPI0WriteN);  // 3 bytes chip address
	ToSPIAdr3B(MemAdr);
	ToCmdBuf(CmdSPI0UnloadN);  // unload data into chip page
	ToCmdBuf(CellPerPage);
	ToCmdBuf(CmdSPI0CS1);  // Chip disable
}
rc SPIDownBuf(int len) {
	int Pages, i;
	vpData = SSEG1;  // initial the buffer pointer
	Pages = (len + CellPerPage - 1) / CellPerPage;
	for (i=0; i<Pages; i++) {
	  _SPIWritePage(ICAdr);  // prepare the command report
	  if (WriteReport(OutBuf)) return 1;  // send out the command report
      temp = ReportPerPage;
      while (temp) {  // load XDATA buffer with data report
        LoadOutBuf();
        if (WriteReport(OutBuf)) return 2;
        temp--;
  	  }
  	  if (CheckStatusRPT()) return 3;
      ICAdr = ICAdr + CellPerPage;  // update IC address
	}
	return (WaitWIP(2));  // Wait 2x10ms at most for the last write to complete
}

// data upload
void _SPIReadReports(int Reports, int MemAdr) {
	InitCmdBuf();
	ToCmdBuf(CmdSPI0CS0_Byte);  // Chip enable with "READ" command
	ToCmdBuf(READ);
	ToCmdBuf(CmdSPI0WriteN);  // 3 bytes chip address
	ToSPIAdr3B(MemAdr);
	ToCmdBuf(CmdSPI0ReadReportL);  // need to read so many reports
	ToCmdBuf(Reports >> 8);  ToCmdBuf(Reports);
	ToCmdBuf(CmdSPI0CS1);  // Chip disable
}
rc SPIUpBuf() {
	int Reports, i, j;
	Reports = (ReportPerIC <= ReportPerBuf) ? ReportPerIC : ReportPerBuf;
	_SPIReadReports(Reports, ICAdr);  // prepare the command report
	if (WriteReport(OutBuf)) return 1;  // send out the command report
	vpData = SSEG1;
	for(i=0; i < Reports; i++) {  // read reports into PC buffer
	  if (ReadReport(InBuf))  return 1;
	  for(j=0; j < PKGLen; j++)  *vpData++ = InBuf[j];
	}
	return CheckStatusRPT();  // read the status report
}
rc UpSPI() {
	pfUpBuf = SPIUpBuf;  // set vector
	return (UpIC());  // it takes about 10 seconds to upload a MX25L4005
}
rc DownSPI() {
	pfDownBuf = SPIDownBuf;  // set vector
	return (DownIC());
}

rc ReadIDJED() {  // read chip ID
	InitCmdBuf();
	ToCmdBuf(CmdSPI0CS0_Byte);  // Chip enable with "RDID" command
	ToCmdBuf(RDID);
	ToCmdBuf(CmdSPI0ReadN);  // read 3 bytes
	ToCmdBuf(3);
	ToCmdBuf(CmdSPI0CS1);  // Chip disable
	return (SendCmdPKG());
}
rc WriteSR(int SR) {  // write chip's status register
	InitCmdBuf();
	ToCmdBuf(CmdSPI0CS0_Byte);  // Chip enable with "WREN" command
	ToCmdBuf(WREN);
	ToCmdBuf(CmdSPI0CS1);  // Chip disable
	ToCmdBuf(CmdSPI0CS0_Byte);  // Chip enable with "WRSR" command
	ToCmdBuf(WRSR);
	ToCmdBuf(CmdSPI0WriteN);  // write one byte of data
	ToCmdBuf(1);
	ToCmdBuf(SR);
	ToCmdBuf(CmdSPI0CS1);  // Chip disable
	ToCmdBuf(CmdWaitWIPL);  // wait at most 2x10ms for write to complete
	ToCmdBuf(0);  ToCmdBuf(2);
	return (SendCmdPKG());
}
rc EraseChip(int CERTime) {
	InitCmdBuf();
	ToCmdBuf(CmdSPI0CS0_Byte);  // Chip enable with "WREN" command
	ToCmdBuf(WREN);
	ToCmdBuf(CmdSPI0CS1);  // Chip disable
	ToCmdBuf(CmdSPI0CS0_Byte);  // Chip enable with "CER" command
	ToCmdBuf(CER);
	ToCmdBuf(CmdSPI0CS1);  // Chip disable
	ToCmdBuf(CmdWaitWIPL);  // wait at most CERTime*10ms for chip to erase
	ToCmdBuf(CERTime >> 8);  ToCmdBuf(CERTime);
	return (SendCmdPKG());
}
void Init25L1005() {
	CellPerPage = 256;
	PagePerIC = 512;
	MaxEraseTime = 200;  // 2 seconds in 10mS unit
	SetPara();
}
void Init25L4005() {
	CellPerPage = 256;
	PagePerIC = 2048;
	MaxEraseTime = 750;  // 7.5 seconds in 10mS unit
	SetPara();
}

int main(int argc, char* argv[]) {
	// Input user parameters
	char ic, rw, yn;
	char name[80];
	printf("select (1)MX25L1005 (2)MX25L4005 or ESC to abort:");
	while (!((ic = getch()) == 0x1B || ic == '1' || ic == '2'));
	if (ic == 0x1B)  return 0;
    putch(ic);
	printf("\nSelect (1)Read (2)Write or ESC to abort:");
	while (!((rw = getch()) == 0x1B || rw == '1' || rw == '2'));
	if (rw == 0x1B)  return 0;
    putch(rw);
	do {
	  printf("\nEnter filename:");
	  gets(name);
	  if (rw == '1')  temp = ((fp = fopen(name, "wb")) == NULL);
	  else  temp = ((fp = fopen(name, "rb")) == NULL);
	  if (temp)  printf("\nCan't open %s\n", name);
	  else  break;
	  printf("\nRetry (1)Yes (2)No:");
	  while (!((yn = getch()) == '1' || yn == '2'));
      putch(yn);
	  if (yn == '2')  return 0;
	} while (1);
	// File is opened. Now open the DLL
    HINSTANCE hDLL = LoadLibrary("F320hid.dll");
    if (hDLL == NULL)  return 1;
    OpenU2A = (OpenU2A_type)GetProcAddress(hDLL, "OpenU2A");
    CloseU2A = (CloseU2A_type)GetProcAddress(hDLL, "CloseU2A");
    ReadReport = (ReadReport_type)GetProcAddress(hDLL, "ReadReport");
    WriteReport = (WriteReport_type)GetProcAddress(hDLL, "WriteReport");
    SetMaxWaitTime = (SetMaxWaitTime_type)GetProcAddress(hDLL, "SetMaxWaitTime");
	// open device
    rcode = OpenU2A();
    if (rcode)  {FreeLibrary(hDLL);  fclose(fp);  return 1;}

    // SPI test
    if (PowerOn())  goto error;
    if (SelSIO())  goto error;
    if (InitSPI())  goto error;
    if (ic == '1')  Init25L1005();  else  Init25L4005();
    if (ReadIDJED()) goto error;
    printf("\nThe ID of manufacture, type and density are %x, %x, %x", InBuf[2], InBuf[3], InBuf[4]);
    if (rw == '1') {
      printf("\nUploading...");
      rcode = UpSPI();
    }
    else {
	  if (WriteSR(0))  return 1;  // clear all block protection bits
	  // if MaxEraseTime is longer than the wait_report_timeout which is 5 seconds by default,
	  // You may increase the wait_report_timeout or ...
	  if (MaxEraseTime * 10 > 5000)  SetMaxWaitTime(MaxEraseTime * 10 + 1000);  // add one more second
      printf("\nErase chip ...");
	  rcode = EraseChip(MaxEraseTime);
	    // ... to wait it longer by calling the ReadReport(InBuf) again
		// if (rcode) {
		//   if (rcode == 0x103)  rcode = ReadReport(InBuf);  // if wait_report_timeout, wait it longer
		// }
	  SetMaxWaitTime(5000);  // back to default value
  	  if (rcode)  return 1;
      printf("\nWrite chip ...");
	  rcode = DownSPI();
	}
	SPIDis();
	PowerOff();

    // The codes below are common to all applications
    error:
    CloseU2A();
	FreeLibrary(hDLL);
    fclose(fp);
    if (rcode)  {
	  printf("\nError occurs at offset %d in command reprot", ((InBuf[1] & 0x3F)-1));
	  printf("\nPress any key to exit");
      getch();
	}
    return rcode;
}
