// A simple example to read out some bytes from AT24C04
void _ToI2CAdr1B(int MemAdr)  {  // push R/W control byte and address(1 byte) into command report
	ToCmdBuf(2);
	ToCmdBuf((MemAdr >> 8) << 1 | 0xA0);
	ToCmdBuf(MemAdr);
}
rc InitI2C() {
	InitCmdBuf();
	ToCmdBuf(CmdSMB0En);
	return (SendCmdPKG());
}
rc SetI2CAdr(int MemAdr) {
	InitCmdBuf();
	ToCmdBuf(CmdSMB0Start);
	ToCmdBuf(CmdSMB0WriteN);
	_ToI2CAdr1B(MemAdr);
	ToCmdBuf(CmdSMB0Stop);
	return (SendCmdPKG());
}

// Read data
int SAdr, Size;
rc Read6Bytes() {
	InitCmdBuf();
	ToCmdBuf(CmdSMB0Start);  // start
	ToCmdBuf(CmdSMB0WriteN); // dummy write
	ToCmdBuf(1);
	ToCmdBuf(0xA1);
	ToCmdBuf(CmdSMB0ReadN); // read "Size" bytes with ACK
	ToCmdBuf(Size);
	ToCmdBuf(CmdSMB0NACKStop); // NACK and stop
	return (SendCmdPKG());
}

int main(int argc, char* argv[]) {
	int i;
	// Open the DLL
    HINSTANCE hDLL = LoadLibrary("F320hid.dll");
    if (hDLL == NULL)  return 1;
    OpenU2A = (OpenU2A_type)GetProcAddress(hDLL, "OpenU2A");
    CloseU2A = (CloseU2A_type)GetProcAddress(hDLL, "CloseU2A");
    ReadReport = (ReadReport_type)GetProcAddress(hDLL, "ReadReport");
    WriteReport = (WriteReport_type)GetProcAddress(hDLL, "WriteReport");
	// Open device
    rcode = OpenU2A();
    if (rcode)  {FreeLibrary(hDLL);  return 1;}
    // ask the parameters
    printf("\nEnter the start address(hex):");
    scanf("%x", &SAdr);
    printf("\nEnter the number of bytes to read(32 max.):");
    scanf("%d", &Size);
    if (Size > 32) {
	  printf("\nSize round to 32");
	  Size = 32;
    }
    // I2C access
    if (PowerOn())  goto error;
    if (SelSIO())  goto error;
    if (InitI2C())  goto error;
	if (SetI2CAdr(SAdr))  goto error;
    rcode = Read6Bytes();
    printf("\nThe data in Status Report are:\n");
    for(i=0; i<Size; i++)  printf("%3x", InBuf[i+2]);
	PowerOff();  // This command will clear the InBuf[] buffer

    //
    error:
    CloseU2A();
	FreeLibrary(hDLL);
    if (rcode)  {
	  printf("\nError occurs at offset %d in command reprot", ((InBuf[1] & 0x3F)-1));
    }
	printf("\nPress any key to exit");
    getch();
    return rcode;
}
