// USB2Any command code define
enum CmdCode {
// General
CmdGetVer=1, CmdPowerOn, CmdPowerOff, CmdSFRRead, CmdSFRWrite,
CmdSetPWidth, CmdWaitN100uS, CmdSelEPP, CmdSelSPP, CmdSelSIO, CmdLoadReportN,
// SPI, $0C
CmdSPI0SetRate, CmdSPI0En, CmdSPI0Dis, CmdSPI0CS0_Byte, CmdSPI0CS1, CmdSPI0WriteN, CmdSPI0ReadN,
CmdWaitWIPL, CmdSPI0UnloadN, CmdSPI0ReadReportL,
// I2C, $16
CmdSMB0SetRate, CmdSMB0En, CmdSMB0Dis, CmdSMB0Start, CmdSMB0Stop, CmdSMB0NACKStop, CmdSMB0ReadN,
CmdSMB0Read_NACK, CmdSMB0WriteN, CmdSMB0UnloadN, CmdSMB0ReadReportL,
// PORT I/O, $21
CmdPBitSet, CmdPBitClr, CmdStbWrite,
CmdStbWriteN, CmdDStbWrite, CmdDStbRead, CmdAStbWrite, CmdAStbRead, CmdWaitBit0, CmdWaitBit1,
// JTAG, $2B
CmdJTAGReset, CmdTCK_TMS1, CmdTCK_TMS0, CmdTDI1, CmdTDI0, CmdTCKsL, CmdBitsRWExitL, CmdBitsRWL,
// ADC, $33
CmdADC0En, CmdADC0Dis, CmdADC0SetAMX, CmdADC0Get,
// RS232, $37
Cmd232En, Cmd232Read_Flag, Cmd232ReadN, Cmd232WriteN, Cmd232SetBaud,
// Special, $3C
CmdUserReadPage, CmdUserWritePage,
CmdUser0, CmdUser1, CmdUser2, CmdUser3, CmdUser4, CmdUser5, CmdUser6, CmdUser7, CmdUser8, CmdUser9,
// Items added later, $48
CmdSMB0ReStart
};

// define port address
#define P0		0x80
#define P1		0x90
#define P2		0xA0

// define bit address
enum PortBit {
P00=0x80, P01, P02, P03, P04, P05, P06, P07,
P10=0x90, P11, P12, P13, P14, P15, P16, P17,
P20=0xA0, P21, P22, P23, P24, P25, P26, P27,
};




