; Firmware version V01.00
;The following two lines are directives for C32 ASSEMBLER. If you are not using it, remark them out.
	CPU	"8051.TBL"
	HOF	"BIN8"
;

DPKG		EQU	$00C0  ;the start of the XDATA's page buffer for "CmdLoadPage" to load data.

		ORG	$2E00
GetNextP:	LJMP	$0912       ;Get next command parameter byte and returned in the ACC.
StoreToS:	LJMP	$1086       ;Push ACC data into STATUS_REPORT buffer.
ClrIPKG:	LJMP	$0F14       ;Initialize the IN_DATA_REPORT's buffer and pointer
                                    ;Must be called before using IN_DATA_REPORT.
StoreToI:	LJMP	$1048       ;Push ACC data into IN_DATA_REPORT buffer.
SendIPKG:	LJMP	$0F2C       ;Send the IN_DATA_REPORT to PC.
;The above codes shouldn't be modified.
UserCmd0:	LJMP	Cmd0
UserCmd1:	LJMP	Cmd1
UserCmd2:	LJMP	Cmd2
UserCmd3:	LJMP	Cmd3
UserCmd4:	LJMP	Cmd4
UserCmd5:	LJMP	Cmd5
UserCmd6:	LJMP	Cmd6
UserCmd7:	LJMP	Cmd7
UserCmd8:	LJMP	Cmd8
UserCmd9:	LJMP	Cmd9
;The above codes sequence shouldn't be changed.

; In a user's command, all passed N parameters must be taken by calling "GetNextP" N timers before
; its terminate or else the followed commands in COMMAND_REPORT will be interpretted incorrectly.
; R0 shouldn't be modified under any situation.
; IDATA space $50~$6F and $D0~$FF is free to use. XDATA free at $200~$3FF

Cmd0:   ;Cmd0 has one parameter and was just pass back in the STSTUS_REPORT.
	LCALL	GetNextP  ;Get command's parameter
	LCALL	StoreToS  ;Store to STATUS_REPORT buffer
	RET		  ;No need to initialize STATUS_REPORT buffer and its pointer because it has
			  ;been done everytime a COMMAND_REPORT starts.
	
Cmd1:   ;Cmd1 read 64 bytes of codes at $2E00 and send back to PC through one DATA_REPORT.
	LCALL	ClrIPKG  ;Initialize IN_DATA_REPORT buffer
	MOV	DPTR,# $2E00  ;Load start address
	MOV	R2,# $40  ;Load length 64
L1:	CLR	A
	MOVC	A,@A+DPTR  ;can only read an unlocked byte
	LCALL	StoreToI  ;Store to IN_DATA_REPORT buffer
	INC	DPTR
	DJNZ	R2,L1  ;Repeat 64 times
	LCALL	SendIPKG  ;Send IN_DATA_REPORT buffer to PC
	RET
	
Cmd2:	RET
Cmd3:	RET
Cmd4:	RET
Cmd5:	RET
Cmd6:	RET
Cmd7:	RET
Cmd8:	RET
Cmd9:	RET
	
	END


